#include <stdio.h>
#include "defs.h"
#include "files.h"

char dflag;
char pflag;
char vflag;

getargs(argc, argv)
int argc;
char *argv[];
{
  register int i;
  register char *s;
  register int repeats;
  register int nfiles;
  register int ended;

  char *illegal;

  dflag = 0;
  pflag	= 0;
  vflag = 0;
  repeats = 0;
  nfiles = 0;

  for (i = 1; i < argc; i++)
    {
      if (*argv[i] != '-')
	{
	  nfiles++;
	  input_file_name = argv[i];
	}
      else
	{
	  s = argv[i] + 1;
	  ended = 0;
	  while ( ! ended)
	    switch (*s++)
	      {
	      case 'd':
	        if (dflag) repeats = 1;
		dflag = 1;
		if (*s == NUL) ended = 1;
	        break;

	      case 'p':
		if (pflag) repeats = 1;
		pflag = 1;
		if (*s == NUL)
		  {
		    i++;
		    if (i < argc)
		      parser_file_name = argv[i];
		    else
		      fatal("malformed -p option");
		  }
		else
		  parser_file_name = s;
		ended = 1;
		break;

	        case 'v':
		  if (vflag) repeats = 1;
		  vflag = 1;
		  if (*s == NUL) ended = 1;
		  break;

	        default:
		  illegal = "illegal option - ";
		  illegal[16] = s[-1];
		  fatal(illegal);
	        }
	    }
	}

  if (repeats)
    warn("repeated command line arguments");

  if (nfiles == 0)
    fatal("grammar file not specified");

  if (nfiles > 1)
    fatal("too many files");
}
